unit siena_5;

interface

uses
{$if not defined(linux)}
  Windows,
{$ifend}
Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
   {$if defined(lazarus)}
 lresources,
 {$else}
 jpeg,
 {$ifend}
  slib, StdCtrls, Buttons, Grids,
  ExtCtrls, s_base, s_dat,
  s_sim, rangen, Menus;
  procedure TSimFormFormActivate;
type
  TSimForm = class(TForm)
    ERun: TEdit;
    BAbort: TBitBtn;
    Label1: TLabel;
    Label2: TLabel;
    Statsnames: TMemo;
    statas: TMemo;
    Label3: TLabel;
    HelpInfoValue: TEdit;
    HelpInfoLabel: TLabel;
    IlCampo: TImage;
    Graphic1: TPaintBox;
    Graphic1Button: TButton;
    BurninText: TStaticText;
  //  procedure FormActivate(Sender: TObject);
    procedure BAbortClick(Sender: TObject);
    procedure Graphics1Paint(Sender: TObject);
    procedure Startpaint;
    function xcoor(t: real): integer;
    function ycoor(t: real): integer;
(*A0*)
    procedure Drawxaxis(x0,x1: real);
    procedure Drawyaxis(y0,y1: real);
    procedure Draw1(x,y: real);
    procedure HelpInfo(x: real; s: string);
  private
    { Private declarations }
  public
    { Public declarations }
    xmin, xmax, ymin, ymax: real;
  end;
(*A1*)

var
  outfile,lf: TFileStream;
  st1: shortstring;
  ContinueDigraph: Activity;
  SimForm: TSimForm;

implementation

{$IF not DEFINED(LAZARUS)}
{$R *.DFM}
{$IFEND}



procedure TSimFormFormActivate();
var proname: string;
  apf, halter: boolean;
begin
  st1 := ParamStr(1);
  stops :=false;
  halter := false;
  proname := st1;
  apf := true;
  Application.hintpause := 100;
  Application.hinthidepause := 10000;
  Simform.Graphic1.hide;
  with ContinueDigraph do begin
    AttachProject(st1,st1,halter,outfile,lf,apf,true);
    Application.ProcessMessages;
    InitialiseBase1(outfile,lf);
    if not halter then ReviseDefinition(halter,outfile,lf);
    if halter then (* nothing *) else Simulate(outfile,lf);
    DeActivateModel(outfile);
   end;
  SetFree(version);    
  //closefile(outfile);
  //closefile(lf);
  outfile.free;
  lf.free;
  SimForm.Close;
end;

procedure TSimForm.BAbortClick(Sender: TObject);
begin
  if MessageDlg('Are you sure you want to stop the simulations?',mtConfirmation,[mbYes, mbNo],1)
  = mrYes then begin stops:=true; stopo:=true end
end;

procedure TSimForm.HelpInfo(x: real; s: string);
begin
  width := 500;
    with HelpInfoValue do begin
      text := floattostrf(x,fffixed,14,6);
      visible := true;
     end;
    with HelpInfoLabel do begin
     caption := s;
      visible := true;
      end;
end;

(*A0*)
procedure TSimForm.Startpaint;
begin
 with Graphic1 do begin
   Canvas.Pen.Color := clRed;
{$if not defined(linux)}
   SetBkMode(Canvas.Handle,OPAQUE);
   SetBkColor(Canvas.Handle,clWhite);
{$ifend}
   Canvas.Font.Color := clRed;
   Canvas.Brush.Color := clWhite;
   Canvas.Pen.Color := clBlack;
   Canvas.Rectangle(0,0,graphic1.width,graphic1.height);
   Canvas.Font.Color := clBlack;
   Canvas.Pen.Color := clBlack;
 end;
end; (* startpaint *)


function TSimForm.xcoor(t: real): integer;
  begin
    xcoor := round(graphic1.width*(0.1 + 0.8*(t-xmin)/(xmax-xmin)));
  end;

function TSimForm.ycoor(t: real): integer;
  begin
    ycoor := round(graphic1.height*(0.9 - 0.8*(t-ymin)/(ymax-ymin)));
  end;

procedure TSimForm.Drawxaxis(x0,x1: real);
var i: integer; s: shortstring;
begin
  with Graphic1 do
  with Canvas do begin
   Brush.style := bsClear;
   Font.Color := clBlack;
   MoveTo(xcoor(xmin),ycoor(ymin));
   LineTo(xcoor(xmax),ycoor(ymin));
   for i:=0 to 10 do begin
     MoveTo(xcoor(i*(xmax-xmin)/10), ycoor(ymin));
     LineTo(xcoor(i*(xmax-xmin)/10), ycoor(ymin)-10);
    end;
   NiceString2(x0,s);
   Textout(xcoor(xmin)-5, ycoor(ymin)+5, s);
   NiceString2(x1,s);
   Textout(xcoor(xmax)-5, ycoor(ymin)+5, s);
  end; (* with Graphic1 with Canvas *)
end; (* Drawxaxis *)

procedure TSimForm.Drawyaxis(y0,y1: real);
var i: integer; s: shortstring;
begin
  with Graphic1 do
  with Canvas do begin
   Font.Color := clBlack;
   MoveTo(xcoor(xmin),ycoor(ymin));
   LineTo(xcoor(xmin),ycoor(ymax));
   for i:=0 to 10 do begin
     MoveTo(xcoor(xmin), ycoor(i*(ymax-ymin)/10));
     LineTo(xcoor(xmin)+10, ycoor(i*(ymax-ymin)/10));
    end;
   NiceString2(y0,s);
   Textout(xcoor(xmin)-15, ycoor(ymin)-5, s);
   NiceString2(y1,s);
   Textout(xcoor(xmin)-15, ycoor(ymax)-5, s);
  end; (* with Graphic1 with Canvas *)
end; (* Drawyaxis *)

(*A1*)

procedure TSimForm.Draw1(x,y: real);
var OldColor: Tcolor;
begin
  with Graphic1 do begin
   Oldcolor := Font.color;
   Canvas.Ellipse(xcoor(x),ycoor(y),xcoor(x)+2,ycoor(y)+2);
   Font.Color := Oldcolor;
  end; (* with graphic1 *)
end;

procedure TSimForm.Graphics1Paint(Sender: TObject);
begin
  if not ContinueDigraph.Graphix then begin
    ContinueDigraph.Graphix := true;
    Graphic1.show;
    Graphic1Button.Hide;
    IlCampo.Hide;

    Drawxaxis(0.0,1.0);  (*arbitrary, must be changed w\hen used *)
    Drawyaxis(0.0,1.0);
(*    with Graphic1 do
    begin
      Canvas.Pen.Color := clRed;
      SetBkMode(Canvas.Handle,OPAQUE);
      SetBkColor(Canvas.Handle,clWhite);
      Canvas.Font.Color := clRed;
      Canvas.Brush.Color := clWhite;
      Canvas.Pen.Color := clBlack;
      Canvas.Rectangle(0,0,graphic1.width,graphic1.height);
      Canvas.Font.Color := clBlack;
      Canvas.Pen.Color := clBlack;
    end; *)

   end; (* if not graphix *)
    startpaint;
end;
initialization
begin (* Siena_5 *)
 {$if defined(lazarus)}
{$I siena_5.lrs}
{$ifend}
  CallingProgram := 5;
  ContinueDigraph.estimation := false;
  end;
end.


